#!/usr/bin/python
# vim: set ai sts=4 sw=4 ts=8 expandtab:
'''
Caller
'''

import random

class pnCaller:
    '''A part of PyttoNet World Model.
    ݷ ζ  ϴ Դϴ.
      ζ ݷԴϴ.
    '''
    def __init__(self, parent, x=45, y=6):
        self.parent = parent 

        self.max = x
        self.count = y
        self.round = 0
        self.prize = 0
        self.numbers = []
        self.users = []
        self.high_deposit = {'first':[], 'second':[], 'third':[],
                                'forth':[]}
        self.desire()

    def setMax(self, max):
        self.max = max
    def setCount(self, count):
        self.count = count
    def getInfo(self):
        return (self.max, self.count, self.round)

    def desire(self):
        ''' 屸'''
        self.parent.addRequest(30, self)

    def matchLotto(self, ticket, numbers):
        '''װ  Ƽϰ    ڵ 纾ϴ.'''
        matched = [] # for debugging

        for each_of_ticket in ticket:
            for each_of_numbers in numbers:
                if each_of_ticket == each_of_numbers:
                    matched.append(each_of_ticket)
                    break
                elif each_of_ticket < each_of_numbers :
                    break
                else :
                    pass

        #hit = len(matched)                          #
        #if hit >= 3:                                # for debugging
            #print "%s (%d)"%(repr(matched), hit)    #
        return matched

    def checkTicketList(self, dispatcher, numbers):
        '''״  Ƽ  ͼ װ ȣ
        մϴ.
          ̻ ڰ    ֱ ؼ.
        '''

        ticket_list = dispatcher.ticketList # change this to 'get..()'
        deposit = []

        #print "time out: %s"%repr(numbers) # for debugging
        for each in ticket_list:
            matched = self.matchLotto(each, numbers)
            hit = len(matched)
            if hit >= 3:
                deposit.append((each, matched))
        return deposit

    def isValidMessage(self, any):
        return 1

    def stockHigher(self, finance, dispatcher, deposit):
        '''finance  Ű  ȵǴµ..
        ĳ    .
        stockHigher ߸ и   ϴ ׳ Ӵϴ.
        '''
        high_deposit = self.high_deposit

        for each in deposit:
            len_each = len(each[1])
            if len_each == 3:
                finance -= 10000
                dispatcher.income += 10000
            else:
                print len_each
                if len_each == 4:
                    higher = high_deposit['forth']
                elif len_each == 5:
                    higher = high_deposit['third']
                elif len_each == 6:
                    higher = high_deposit['first']

                higher.append((dispatcher, each[1]))

    def signal(self, message):
        '''ܺ ڱ'''
        
        if self.isValidMessage(message) :
            cashier = self.parent.getObject('cashier')
            cashier.closing()
            finance = cashier.withdraw()
            print 'Ѿ: %d'%finance

            finance = finance/2
            cashier.saving(finance)

            new_numbers = self.getAnyNumbers()

            poller = self.parent.poller 
            connected = poller.getConnected()
            listener = poller.getListener()
            for (fd, dispatcher) in connected.items():
                if dispatcher is not listener:
                    deposit = self.checkTicketList(dispatcher, new_numbers)
                    self.stockHigher(finance, dispatcher, deposit)

                    # packaging deposit and send that to dispatcher
                    packet = repr(new_numbers)
                    packet += ' '+'%d'%dispatcher.getBuyingCount()
                    for i in deposit:
                        packet += ' '+repr(i)
                    dispatcher.send('RESULT OK '+packet)
                    # saving data
                    print deposit   # for debugging
                    print('%s spent %d won, and you made a profit of %d won'%(dispatcher.name, dispatcher.outgo, dispatcher.income))

            disconnected = poller.getDisconnected()
            print len(disconnected)
            while disconnected:
                dispatcher = disconnected.pop(0)
                deposit = self.checkTicketList(dispatcher, new_numbers)
                self.stockHigher(finance, dispatcher, deposit)

                # no send
                # saving data
                print deposit       # for debugging
                print('%s spent %d won, and you made a profit of %d won'%(dispatcher.name, dispatcher.outgo, dispatcher.income))

            # for each in all: all.remove(each) հ ̻ϰ
            # Ѵ

            # ÷ й
            higher = self.high_deposit
            print '1:'
            for i in higher['first']:
                print '  %s> %s'%(i[0].name, i[1])

            print '2:'
            for i in higher['second']:
                print '  %s> %s'%(i[0].name, i[1])

            print '3:'
            for i in higher['third']:
                print '  %s> %s'%(i[0].name, i[1])

            print '4:'
            for i in higher['forth']:
                print '  %s> %s'%(i[0].name, i[1])

            #   غ
            self.round += 1
            cashier.opening()
            self.desire()

    def getAnyNumbers(self):
        '''ζ ڵ ´.'''
        numbers = []
        loop_cnt = self.count
        max = self.max

        while len(numbers) < loop_cnt:
            anynumber = random.randint(1, max)
            if anynumber not in numbers:
                numbers.append(anynumber)

        numbers.sort()
        return numbers

