# vim: set ai sts=4 ts=8 sw=4 expandtab:
'''PyttoNet Dispatcher
'''
import asyncore

class pnCustomer(asyncore.dispatcher):
    # System Methods
    def __init__(self, parent, sock=None, map=None):
        self.map = map
        self.parent = parent

        self.name = 'default'
        self.income = 0         #  Ա
        self.outgo = 0          #  
        self.buyingCount = 0    # ̹ ȸ   
        self.ticketList = []

        self.init_keywords()
        asyncore.dispatcher.__init__(self, sock, map)
        self.log_info('[%d] new_dispatcher ok'%self._fileno)

    # Get/Set
    def getFd(self): return self._fileno
    ## use not setFd
    def getName(self): return self.name
    def setName(self, val): self.name = val
    def getIncome(self): return self.income
    def setIncome(self, val): self.income = val
    def getOutgo(self): return self.outgo
    def setOutgo(self, val): self.outgo = val
    def getBuyingCount(self): return self.buyingCount
    ## use not setBuyingCount
    def getTicketList(self): return self.ticketList
    ## use not setTicketList

    # Internal
    def init_keywords(self):
        keywords = self.keywords = {}
        keywords['BUY'] = self.proc_buy
        keywords['LOGIN'] = self.proc_login

    def send(self, data):
        asyncore.dispatcher.send(self, data+'\n')
    
    def writable(self):
        return 0

    def close(self):
        self.del_channel(self.map)
        self.socket.close()
    
    def handle_accept(self):
        self.log_info('[%d] accept ok'%self._fileno)
        (conn, addr) = self.accept()
        new_dispatcher = pnCustomer(self.parent, conn, self.map)

    def handle_read (self):
        stream = self.recv(1024)
        packet_list = stream.splitlines()
        while packet_list:
            packet = packet_list.pop(0)
            (head, message) = packet.split(' ', 1)
            head = head.upper()

            keywords = self.keywords
            if keywords.has_key(head):
                command = self.keywords[head]
                command(message)
            else:
                command = self.proc_dummy
                command(message)
        
    def handle_close(self):
        self.log_info('[%d] close ok'%self._fileno)
        self.close()

        self.parent.poller.disconnected.append(self)

    ## Command Procedures
    def proc_buy(self, data):
        (extra, data) = data.split(' ', 1)
        extra = extra.upper()
        if extra == 'NULL':
            cashier = self.parent.getObject('cashier')
            if cashier is not None:
                ticket = data.split()
                len_ticket = len(ticket)
                if len_ticket == 6:
                    for i in range(0, len_ticket):
                        ticket[i] = int(ticket[i])
                    ticket.sort()
                    if cashier.buyTicket(self, ticket):
                        self.buyingCount += 1
                        print self.name+'> ', ticket
                        self.send('BUY OK')
                        return 1
                    else:
                        error_reason = 'cashier is not sale.'
                else: 
                    error_reason = 'not enough marking.'
            else:
                error_reason = 'no cashier.'
        self.send('BUY ERROR '+error_reason)
        return 0
    
    def proc_dummy(self, data):
        print('I recieved \'%s\''%data)

    def proc_login(self, data):
        self.name = data
        self.log_info('he/she\'s name is %s'%data)

        caller = self.parent.getObject('caller')
        self.send('LOGIN OK %d %d %d'%caller.getInfo())

    # External
    def addTicket(self, ticket):
        ticketList = self.getTicketList()
        ticketList.append(ticket)

    def addOutgo(self, val):
        self.setOutgo(self.getOutgo() + val)

