#!/usr/bin/python
# vim: set ai sts=4 sw=4 ts=8 expandtab:
'''
PyttoNet core
'''

from customer import *
from caller import *
from cashier import *
import random, asyncore, time, threading, sys, socket, server

class pnServer(server.Server):
    def __init__(self):
        server.Server.__init__(self)

    def poll(self):
        poller = self.poller = pnPoller(self)
        poller.listen()
        self.polling_thr = threading.Thread(target=poller)

    def initObjects(self):
        caller = self.caller = pnCaller(self)
        self.objects['caller'] = caller
        cashier = self.cashier = pnCashier(self)
        self.objects['cashier'] = cashier
        return 1

    def loop(self, sec):
        requests = self.requests
        while 1:
            if len(requests) > 0:
                (request_time, ref) = requests[0]
                now = time.time()
                if now >= request_time:
                    requests.pop()
                    ref.signal('GO NULL')

            time.sleep(sec)

class pnPoller(server.Poller):
    ''' 
    '''
    def __init__(self, parent, host='localhost', port=19999):
        self.parent = parent
        server.Poller.__init__(self, parent)

    def listen(self):
        listener = self.listener = pnCustomer(self.parent, self.conn, self.connected)
        listener.set_reuse_addr()
        listener.listen(5)

    def loop(self):
        asyncore.loop(1.0, map=self.connected)

def __test__():
    server = pnServer()
    server.start()

if __name__ == '__main__':
    __test__()

